package com.fc2.blog68.symfoware.ikensyo;

import java.awt.Component;

import javax.swing.ImageIcon;

import jp.nichicom.ac.core.ACAffairInfo;
import jp.nichicom.ac.core.ACFrame;
import jp.nichicom.ac.component.mainmenu.ACMainMenuButton;
import jp.nichicom.vr.layout.VRLayout;
import jp.nichicom.vr.util.VRHashMap;
import jp.nichicom.vr.component.VRLabel;
import jp.nichicom.vr.container.VRPanel;
import jp.or.med.orca.ikensho.affair.IkenshoFrameEventProcesser;
import jp.or.med.orca.ikensho.affair.IkenshoMainMenu;

public class MainMenu extends IkenshoMainMenu {

    /**
     * ACR̉摜͂炩q؂܂B
	 * http://www.iconspedia.com/
	 */
	private static final long serialVersionUID = 1L;
	
	VRPanel targetPanel = null;
	ACMainMenuButton closeButton = null;
	
	public static void main(String[] args) {
    	
    	
        try {
        	
            ACFrame.setVRLookAndFeel();

            ACFrame.getInstance().setFrameEventProcesser(
                    new IkenshoFrameEventProcesser());
            ACFrame.getInstance().next(
                    new ACAffairInfo(MainMenu.class.getName(),
                            new VRHashMap(), "u㌩Ver2.5vCj["));
            ACFrame frame = ACFrame.getInstance();
            frame.setVisible(true);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
    }
	
    public MainMenu() {
    	
    	steal();
    	if (targetPanel == null){
    		return;
    	}
    	targetPanel.removeAll();
    	ACMainMenuButton extentionButton = new ACMainMenuButton("ǉ@\(S)");
    	extentionButton.setToolTipText("g@\j[\܂BB");
    	extentionButton.setMnemonic('S');
        
    	extentionButton.setIcon(new ImageIcon(getClass().getClassLoader().getResource(
        	"com/fc2/blog68/symfoware/image/01.png")));
        
    	//{^Ƃ̓`ǉ
    	extentionButton.addActionListener(new ExtentionButtonActionListener());
    	
    	targetPanel.add(extentionButton, VRLayout.CLIENT);
    	targetPanel.add(closeButton, VRLayout.CLIENT);
    }
    
    private void steal() {
    	
    	int count = this.getComponentCount();
    	
    	for (int i = 0; i < count; i++){
    		Component c = this.getComponent(i);
    		
    		if (c instanceof VRPanel){
    			VRPanel p1 = (VRPanel)c;
    			int p1count = p1.getComponentCount();
    			for (int j = 0; j < p1count; j++){
    				Component p1c = p1.getComponent(j);
    				if (p1c instanceof VRPanel) {
    					VRPanel p2 = (VRPanel)p1c;
    					int p2count = p2.getComponentCount();
    					for (int k = 0; k < p2count; k++){
    						Component p2c = p2.getComponent(k);
    						if (p2c instanceof VRPanel) {
    							VRPanel p3 = (VRPanel)p2c;
    							
    							int p3count = p3.getComponentCount();
    							for (int l = 0; l < p3count; l++){
    								Component p3c = p3.getComponent(l);
    								if (p3c instanceof ACMainMenuButton){
    									closeButton = (ACMainMenuButton)p3c;
    									if ((targetPanel != null) && (closeButton != null)) {
    										return;
    									}
    								}
    							}
    						} else if (p2c instanceof VRLabel) {
    							targetPanel = p2;
								if ((targetPanel != null) && (closeButton != null)) {
									return;
								}
    						}
    					}
    				}
    			}
    		}
    	}
    }
}
